{copyright 1986 by Herb Barad}
{Protocol is a program to produce a PICT representation of a class}
{hierarchy from a textual description.}
{parts from Flow MacApp sample - copyright 1986 by Apple Computer}

UNIT UProtocol;

INTERFACE

USES
	MemTypes, QuickDraw, OSIntf, ToolIntf, PackIntf,

	UObject,
	UList,
	UMacApp,
	UPrinting,
	UTEView,

	UProtocolChart;

TYPE

	TProtocolApplication = OBJECT(TApplication)

	  {Creation & Initialization}
		PROCEDURE TProtocolApplication.IProtocolApplication;
		FUNCTION  TProtocolApplication.DoMakeDocument(itsCmdNumber: CmdNumber): TDocument; OVERRIDE;
		FUNCTION  TProtocolApplication.DoMenuCommand(aCmdNumber: CmdNumber): TCommand; OVERRIDE;
		PROCEDURE TProtocolApplication.DoSetupMenus; OVERRIDE;
		END;


	TProtocolDocument = OBJECT(TDocument)
		fOutlineView:	TOutlineView;
		fChartView: 	TChartView;
		fText:			Handle;
		fTree:			TTree;
		fPICT:			PicHandle;

		PROCEDURE TProtocolDocument.IProtocolDocument;
		PROCEDURE TProtocolDocument.FreeData; OVERRIDE;

		PROCEDURE TProtocolDocument.DoNeedDiskSpace(VAR dataForkBytes, rsrcForkBytes: LONGINT); OVERRIDE;
		PROCEDURE TProtocolDocument.DoRead(aRefNum: INTEGER; rsrcExists, forPrinting: BOOLEAN); OVERRIDE;
		PROCEDURE TProtocolDocument.DoWrite(aRefNum: INTEGER; makingCopy: BOOLEAN); OVERRIDE;
		PROCEDURE TProtocolDocument.DoMakeViews(forPrinting: BOOLEAN); OVERRIDE;
		PROCEDURE TProtocolDocument.DoMakeWindows; OVERRIDE;
		FUNCTION  TProtocolDocument.DoMenuCommand(aCmdNumber: CmdNumber): TCommand; OVERRIDE;
		END;


	TOutlineView = OBJECT(TTEView)
		fProtocolDoc:	TProtocolDocument;

	  {Creation and Destruction}
		PROCEDURE TOutlineView.IOutlineView(itsDocument: TProtocolDocument; aText: Handle);

	  {Menu Events}
		PROCEDURE TOutlineView.DoSetupMenus; OVERRIDE;
		FUNCTION  TOutlineView.DoMenuCommand(aCmdNumber: CmdNumber): TCommand; OVERRIDE;

	END;


	TChartView = OBJECT(TView)
		fProtocolDoc:	TProtocolDocument;
		fMinSize:	Point;
		fTree:		TTree;
		fShadow:	BOOLEAN;

	  {Creation and Destruction}
		PROCEDURE TChartView.IChartView(itsDocument: TProtocolDocument);

	  {Menu Events}
		PROCEDURE TChartView.DoSetupMenus; OVERRIDE;
		FUNCTION  TChartView.DoMenuCommand(aCmdNumber: CmdNumber): TCommand; OVERRIDE;

	  {Window Update Events}
		PROCEDURE TChartView.Draw(area: Rect); OVERRIDE;

	  {View size}
		PROCEDURE TChartView.CalcMinExtent(VAR minExtent: Rect); OVERRIDE;
		PROCEDURE TChartView.DoPrinterChanged; OVERRIDE;

	  {Application Specific}
		PROCEDURE TChartView.GeneratePict;

	END;

	TKWCommand = OBJECT(TTECommand)

	PROCEDURE TKWCommand.IKWCommand(itsTEView: TTEView; itsCmdNumber: CmdNumber;
							 s: Str255);
	END;


IMPLEMENTATION

{$I UProtocol.inc1.p}

END.



